MONGOS(1)

NAME
mongos - MongoDB Sharded Cluster Query Router

SYNOPSIS

mongos for "MongoDB Shard," is a routing service for MongoDB shard configurations that processes queries from the application layer, and determines the location of this data in the sharded cluster, in order to complete these operations. From the perspective of the application, a mongos instance behaves identically to any other MongoDB instance.

CONSIDERATIONS

Never change the name of the mongos binary.

OPTIONS

  Core Options

mongos

--help, -h
    Returns information on the options and use of mongos.

--version
    Returns the mongos release number.

--config <filename>, -f <filename>
    Specifies a configuration file for runtime configuration options. The configuration file is the preferred method for runtime configuration of mongos. The options are equivalent to the command-line configuration options. See http://docs.mongodb.org/manual/reference/configuration-options for more information.

    Ensure the configuration file uses ASCII encoding. The mongos instance does not support configuration files with non-ASCII encoding, including UTF-8.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs the mongos in a quiet mode that attempts to limit the amount of output.

    This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--port <port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

--bind_ip <ip address>
    Default: All interfaces.

    Changed in version 2.6.0: The deb and rpm packages include a default configuration file that sets --bind_ip to 127.0.0.1.

    Specifies the IP address that mongos binds to in order to listen for connections from applications. You may attach mongos to any interface. When attaching mongos to a publicly accessible interface, ensure that you have implemented proper authentication and firewall restrictions to protect the integrity of your database.

--maxConns <number>
    Specifies the maximum number of simultaneous connections that mongos will accept. This setting will have no effect if the value of this setting is higher than your operating system's configured maximum connection tracking threshold.

    This setting is particularly useful for mongos if you have a client that creates a number of connections but allows them to timeout rather than close the connections. When you set maxIncomingConnections, ensure the value is slightly higher than the size of the connection pool or the total number of connections to prevent erroneous connection spikes from propagating to the members of a sharded cluster.

    Changed in version 2.6: MongoDB removed the upward limit on the maxIncomingConnections setting.

--syslog
    Sends all logging output to the host's syslog system rather than to standard output or to a log file. , as with --logpath.

    The --syslog option is not supported on Windows.

--syslogFacility <string>
    Default: user

    Specifies the facility level used when logging messages to syslog. The value you specify must be supported by your operating system's implementation of syslog. To use this option, you must enable the --syslog option.

--logpath <path>
    Sends all diagnostic logging information to a log file instead of to standard output or to the host's syslog system. MongoDB creates the log file at the path you specify.

    By default, MongoDB overwrites the log file when the process restarts. To instead append to the log file, set the --logappend option.

--logappend
    Appends new entries to the end of the log file rather than overwriting the content of the log when the mongos instance restarts.

--timeStampFormat <string>
    Default: iso8601-local

    The time format for timestamps in log messages. Specify one of the following values:
    Value | Description
    ctime | Displays timestamps as Wed Dec 31 18:17:54.811.
    iso8601-utc | Displays timestamps in Coordinated Universal Time (UTC) in the ISO-8601 format. For example, for New York at the start of the Epoch: 1970-01-01T00:00:00.000Z
    iso8601-local | Displays timestamps in local time in the ISO-8601 format. For example, for New York at the start of the Epoch: 1969-12-31T19:00:00.000+0500

--pidfilepath <path>
    Specifies a file location to hold the process ID of the mongos process where mongos will write its PID. This is useful for tracking the mongos process in combination with the --fork option. Without a specified --pidfilepath option, the process creates no PID file.

--keyFile <file>
    Specifies the path to a key file that stores the shared secret that MongoDB instances use to authenticate to each other in a sharded cluster or replica set. --keyFile implies --auth. See inter-process-auth for more information.

--setParameter <options>
    Specifies one of the MongoDB parameters described in http://docs.mongodb.org/manual/reference/parameters. You can specify multiple setParameter fields.

--httpinterface
    New in version 2.6.

    Enables the HTTP interface. Enabling the interface can increase network exposure.

    Leave the HTTP interface disabled for production deployments. If you do enable this interface, you should only allow trusted clients to access this port. See security-firewalls.

    NOTE: In MongoDB Enterprise, the HTTP Console does not support Kerberos Authentication.

--nounixsocket
    Disables listening on the UNIX domain socket. The mongos process always listens on the UNIX socket unless one of the following is true:

•   --nounixsocket is set

•   bindIp is not set

•   bindIp does not specify 127.0.0.1

    New in version 2.6: mongos installed from official .deb and .rpm packages have the bind_ip configuration set to 127.0.0.1 by default.

--unixSocketPrefix <path>
    Default: /tmp

    The path for the UNIX socket. If this option has no value, the mongos process creates a socket with /tmp as a prefix. MongoDB creates and listens on a UNIX socket unless one of the following is true:

•   --nounixsocket is set

•   bindIp is not set

•   bindIp does not specify 127.0.0.1

--fork
    Enables a daemon mode that runs the mongos process in the background. By default mongos does not run as a daemon: typically you will run mongos as a daemon, either by using --fork or by using a controlling process that handles the daemonization process (e.g. as with upstart and systemd).

  Sharded Cluster Options

--configdb <config1>,<config2>,<config3>
    Specifies the configuration database for the sharded cluster. You must specify either 1 or 3 configuration servers, in a comma separated list. Always use 3 config servers in production environments.

    All mongos instances must specify the exact same value for --configdb

    If your configuration databases reside in more that one data center, order the hosts so that first config sever in the list is the closest to the majority of your mongos instances.

    WARNING: Never remove a config server from this setting, even if the config server is not available or offline.

--localThreshold
    Default: 15

    Affects the logic that mongos uses when selecting replica set members to pass read operations from clients. Specify a value in milliseconds. The default value of 15 corresponds to the default value in all of the client drivers.

    When mongos receives a request that permits reads to secondary members, the mongos will:

•   Find the member of the set with the lowest ping time.

•   Construct a list of replica set members that is within a ping time of 15 milliseconds of the nearest suitable member of the set.

    If you specify a value for the --localThreshold option, mongos will construct the list of replica members that are within the latency allowed by this value.

•   Select a member to read from at random from this list.

    The ping time used for a member compared by the --localThreshold setting is a moving average of recent ping times, calculated at most every 10 seconds. As a result, some queries may reach members above the threshold until the mongos recalculates the average.

    See the replica-set-read-preference-behavior-member-selection section of the read preference documentation for more information.

--upgrade
    Updates the meta data format used by the config database.

--chunkSize <value>
    Default: 64

    Determines the size in megabytes of each chunk in the sharded cluster. A size of 64 megabytes is ideal in most deployments: larger chunk size can lead to uneven data distribution; smaller chunk size can lead to inefficient movement of chunks between nodes.

    This option affects chunk size only when you initialize the cluster for the first time. If you later modify the option, the new value has no effect. See the http://docs.mongodb.org/manual/tutorial/modify-chunk-size-in-sharded-cluster procedure if you need to change the chunk size on an existing sharded cluster.

--noAutoSplit
    Prevents mongos from automatically inserting metadata splits in a sharded collection. If set on all mongos instances, this prevents MongoDB from creating new chunks as the data in a collection grows.

    Because any mongos in a cluster can create a split, to totally disable splitting in a cluster you must set --noAutoSplit on all mongos.

    WARNING: With --noAutoSplit enabled, the data in your sharded cluster may become imbalanced over time. Enable with caution.

  SSL Options

  See

http://docs.mongodb.org/manual/tutorial/configure-ssl for full documentation of MongoDB's support.

--sslOnNormalPorts
    Deprecated since version 2.6.

    Enables SSL for mongos.

    With --sslOnNormalPorts, a mongos requires SSL encryption for all connections on the default MongoDB port, or the port specified by --port. By default, --sslOnNormalPorts is disabled.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslMode <mode>
    New in version 2.6.

    Enables SSL or mixed SSL used for all network connections. The argument to the --sslMode option can be one of the following:
    Value | Description
    disabled | The server does not use SSL.
    allowSSL | Connections between servers do not use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    preferSSL | Connections between servers use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    requireSSL | The server uses and accepts only SSL encrypted connections.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyFile <filename>
    New in version 2.2.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    When SSL is enabled, you must specify --sslPEMKeyFile.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.2.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongos will redact the password from all logging and reporting output.

    Changed in version 2.6: If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongos will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--clusterAuthMode <option>
    Default: keyFile

    New in version 2.6.

    The authentication mode used for cluster authentication. If you use internal x.509 authentication, specify so here. This option can have one of the following values:
    Value | Description
    keyFile | Use a keyfile for authentication. Accept only keyfiles.
    sendKeyFile | For rolling upgrade purposes. Send a keyfile for authentication but can accept both keyfiles and x.509 certificates.
    sendX509 | For rolling upgrade purposes. Send the x.509 certificate for authentication but can accept both keyfiles and x.509 certificates.
    x509 | Recommended. Send the x.509 certificate for authentication and accept only x.509 certificates.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the x.509 certificate-key file for membership authentication for the cluster or replica set.

    If --sslClusterFile does not specify the .pem file for internal cluster authentication, the cluster uses the .pem file specified in the --sslPEMKeyFile option.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the x.509 certificate-key file specified with --sslClusterFile. Use the --sslClusterPassword option only if the certificate-key file is encrypted. In all cases, the mongos will redact the password from all logging and reporting output.

    If the x.509 key file is encrypted and you do not specify the --sslClusterPassword option, the mongos will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.4.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

    WARNING: If the --sslCAFile option and its target file are not specified, x.509 client and member authentication will not function. mongod, and mongos in sharded systems, will not be able to verify the certificates of processes connecting to it against the trusted certificate authority (CA) that issued them, breaking the certificate chain.

    As of version 2.6.4, mongod will not start with x.509 authentication enabled if the CA file is not specified.

--sslCRLFile <filename>
    New in version 2.4.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslWeakCertificateValidation
    New in version 2.4.

    Changed in version 3.0.0: --sslAllowConnectionsWithoutCertificates became --sslWeakCertificateValidation. For compatibility, MongoDB processes continue to accept --sslAllowConnectionsWithoutCertificates, but all users should update their configuration files.

    Disables the requirement for SSL certificate validation that --sslCAFile enables. With the --sslWeakCertificateValidation option, the mongos will accept connections when the client does not present a certificate when establishing the connection.

    If the client presents a certificate and the mongos has --sslWeakCertificateValidation enabled, the mongos will validate the certificate using the root certificate chain specified by --sslCAFile and reject clients with invalid certificates.

    Use the --sslWeakCertificateValidation option if you have a mixed deployment that includes clients that do not or cannot present certificates to the mongos.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for SSL certificates on other servers in the cluster and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in SSL certificates, when connecting to other mongos instances for inter-process authentication. This allows mongos to connect to other mongos instances if the hostnames in their certificates do not match their configured hostname.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslFIPSMode
    New in version 2.4.

    Directs the mongos to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use the --sslFIPSMode option.

    NOTE: FIPS Compatible SSL is available only in MongoDB Enterprise. See http://docs.mongodb.org/manual/tutorial/configure-fips for more information.

  Audit Options

--auditDestination
    New in version 2.6.

    Enables auditing. The --auditDestination option can have one of the following values:
    Value | Description
    syslog | Output the audit events to syslog in JSON format. Not available on Windows. Audit messages have a syslog severity level of info and a facility level of user. The syslog message limit can result in the truncation of audit messages. The auditing system will neither detect the truncation nor error upon its occurrence.
    console | Output the audit events to stdout in JSON format.
    file | Output the audit events to the file specified in --auditPath in the format specified in --auditFormat.

    NOTE: Available only in MongoDB Enterprise.

--auditFormat
    New in version 2.6.

    Specifies the format of the output file for auditing if --auditDestination is file. The --auditFormat option can have one of the following values:
    Value | Description
    JSON | Output the audit events in JSON format to the file specified in --auditPath.
    BSON | Output the audit events in BSON binary format to the file specified in --auditPath.

    Printing audit events to a file in JSON format degrades server performance more than printing to a file in BSON format.

    NOTE: Available only in MongoDB Enterprise.

--auditPath
    New in version 2.6.

    Specifies the output file for auditing if --auditDestination has value of file. The --auditPath option can take either a full path name or a relative path name.

    NOTE: Available only in MongoDB Enterprise.

--auditFilter
    New in version 2.6.

    Specifies the filter to limit the types of operations the audit system records. The option takes a string representation of a query document of the form:

    { <field1>: <expression1>, ... }

    The <field> can be any field in the audit message, including fields returned in the param document. The <expression> is a query condition expression.

    To specify an audit filter, enclose the filter document in single quotes to pass the document as a string.

    To specify the audit filter in a configuration file, you must use the YAML format of the configuration file.

    NOTE: Available only in MongoDB Enterprise.

  Additional Options

--ipv6
    Enables IPv6 support and allows the mongos to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes disable IPv6 support by default.

--jsonp
    Permits JSONP access via an HTTP interface. Enabling the interface can increase network exposure. The --jsonp option enables the HTTP interface, even if the HTTP interface option is disabled.

--noscripting
    Disables the scripting engine.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2015